=== debian/changelog ===
rustc (1.10.0+dfsg1-3) unstable; urgency=medium

  * Rebuild with LLVM 3.8, same as what upstream are using
  * Dynamically link against LLVM. (Closes: #832565)

 -- Ximin Luo <infinity0@debian.org>  Sat, 30 Jul 2016 22:36:41 +0200

rustc (1.10.0+dfsg1-2) unstable; urgency=medium

  * Tentatively support ARM architectures
  * Include upstream arm64,armel,armhf stage0 compilers (i.e. 1.9.0 stable)
    in a orig-dl tarball, like how we previously did for amd64,i386.

 -- Ximin Luo <infinity0@debian.org>  Fri, 22 Jul 2016 15:54:51 +0200

rustc (1.10.0+dfsg1-1) unstable; urgency=medium

  * New upstream release
  * Add myself to uploaders
  * Update our build process to bootstrap from the previous Debian rustc stable
    version by default. See README.Debian for other options.
  * Update to latest Standards-Version; no changes required.

 -- Ximin Luo <infinity0@debian.org>  Sun, 17 Jul 2016 03:40:49 +0200
