=== debian/changelog ===
rustc (1.15.1+dfsg0-1~exp1ubuntu2~16.10.1) yakkety-security; urgency=medium

  * Rebuild using the rustc binaries in the PPA

 -- Chris Coulson <chris.coulson@canonical.com>  Wed, 01 Mar 2017 08:36:25 +0000

rustc (1.15.1+dfsg0-1~exp1ubuntu1~16.10~1) yakkety; urgency=medium

  * SRU: LP: #1667662. Build for 16.04 LTS.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 27 Feb 2017 09:47:27 +0100

rustc (1.15.1+dfsg0-1~exp1ubuntu2) zesty; urgency=medium

  * Build on all architectures.
  * Disable validation of binary tarballs.
  * Work around a GCC 4.8 ICE on AArch64.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 26 Feb 2017 11:11:49 +0100

rustc (1.15.1+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream release (won't probably be in stretch).
    see the 1.4 git branch for the follow up for stable 
  * d/p/patches/disable-doc-build-in-all.diff:
    all-no-docs no longer exists. Disable the call to doc in all
  * Call to the test renamed from check-notidy => check
  * d/p/disable-check-tool-tidy.diff:
    Disable the call to check-tidy
  * Refresh of the patches

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 03 Feb 2017 15:34:42 +0100

rustc (1.14.0+dfsg1-3ubuntu1) zesty; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Unconditionally build-depend on rustc.
    - Always build using the rustc from the archive.
    - Ignore the test results.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 12 Jan 2017 09:29:09 +0100

rustc (1.14.0+dfsg1-3) unstable; urgency=medium

  * Fix mips64 Makefile patches.
  * Don't run arch-dep tests in a arch-indep build.

 -- Ximin Luo <infinity0@debian.org>  Wed, 04 Jan 2017 21:34:56 +0100

rustc (1.14.0+dfsg1-2) unstable; urgency=medium

  * Update README.Debian, the old one was way out of date.
  * Detect mips CPUs in ./configure and fill in mips Makefile rules.
  * Work around jemalloc-related problems in the upstream bootstrapping
    binaries for arm64, ppc64el, s390x.
  * Disable jemalloc on s390x - upstream already disable it for some other
    arches.
  * Disable jemalloc tests for arches where jemalloc is disabled.
  * We still expect the following failures:
    * arm64 should be fixed (i.e. no failures) compared to the previous upload.
    * armhf will FTBFS due to 'Illegal instruction' and this can only be fixed
      with the next stable rustc release.
    * mips mipsel mips64el ppc64 ppc64el s390x will FTBFS due to yet other
      test failures beyond the ones I fixed above; this upload is only to save
      me manual work in producing nice reports that exhibit these failures.

 -- Ximin Luo <infinity0@debian.org>  Thu, 29 Dec 2016 23:00:47 +0100

rustc (1.14.0+dfsg1-1) unstable; urgency=medium

  [ Sylvestre Ledru ]
  * New upstream release
  * Update debian/watch

  [ Ximin Luo ]
  * Try to bootstrap armhf ppc64 ppc64el s390x mips mipsel mips64el.
    (Closes: #809316, #834003, #839643)
  * Make rust-gdb and rust-lldb arch:all packages.
  * Switch to debhelper 10.

 -- Ximin Luo <infinity0@debian.org>  Sat, 24 Dec 2016 18:03:03 +0100

rustc (1.13.0+dfsg1-2) unstable; urgency=high

  * Skip macro-stepping test on arm64, until
    https://github.com/rust-lang/rust/issues/37225 is resolved.

 -- Luca Bruno <lucab@debian.org>  Sat, 26 Nov 2016 23:40:14 +0000

rustc (1.13.0+dfsg1-1) unstable; urgency=medium

  [ Sylvestre Ledru ]
  * New upstream release.

  [ Ximin Luo ]
  * Use Debian system jquery instead of upstream's embedded copy.

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 11 Nov 2016 13:35:23 +0100

rustc (1.12.1+dfsg1-1) unstable; urgency=medium

  [ Sylvestre Ledru ]
  * New (minor) upstream release
  * Missing dependency from rust-lldb to python-lldb-3.8 (Closes: #841833)
  * Switch to llvm 3.9. (Closes: #841834)

  [ Ximin Luo ]
  * Dynamically apply rust-boot-1.12.1-from-1.12.0.diff.
    This allows us to bootstrap from either 1.11.0 or 1.12.0.
  * Bump LLVM Build-Depends version to get the backported patches for LLVM
    #30402 and #29163.
  * Install debugger_pretty_printers_common to rust-gdb and rust-lldb.
    (Closes: #841835)

 -- Ximin Luo <infinity0@debian.org>  Mon, 07 Nov 2016 14:15:14 +0100

rustc (1.12.0+dfsg1-2) unstable; urgency=medium

  * Ignore test run-make/no-duplicate-libs. Fails on i386
  * Ignore test run-pass-valgrind/down-with-thread-dtors.rs . Fails on arm64
  * I am not switching to llvm 3.9 now because a test freezes. The plan is
    to silent the warning breaking the build and upload 1.12.1 after

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 05 Oct 2016 10:48:01 +0200

rustc (1.12.0+dfsg1-1) unstable; urgency=medium

  * new upstream release
    - Rebase of the patches and removal of deprecated patches

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 29 Sep 2016 20:45:04 +0200

rustc (1.11.0+dfsg1-3) unstable; urgency=medium

  * Fix separate build-arch and build-indep builds.

 -- Ximin Luo <infinity0@debian.org>  Tue, 13 Sep 2016 12:30:41 +0200

rustc (1.11.0+dfsg1-2) unstable; urgency=medium

  * Fix rebuilding against the current version, by backporting a patch I wrote
    that was already applied upstream. Should fix the FTBFS that was observed
    by tests.reproducible-builds.org.
  * Ignore a failing stdcall test on arm64; should fix the FTBFS there.
  * Backport a doctest fix I wrote, already applied upstream.

 -- Ximin Luo <infinity0@debian.org>  Mon, 12 Sep 2016 17:40:12 +0200

rustc (1.11.0+dfsg1-1) unstable; urgency=medium

  * New upstream release
  * Add versioned binutils dependency. (Closes: #819475, #823540)

 -- Ximin Luo <infinity0@debian.org>  Wed, 07 Sep 2016 10:31:57 +0200
