=== debian/control ===
--- 
+++ 
@@ -7,31 +7,35 @@
  Sylvestre Ledru <sylvestre@debian.org>,
  Angus Lees <gus@debian.org>,
  Ximin Luo <infinity0@debian.org>
-Build-Depends: debhelper (>= 9.20141010),
-               dpkg-dev (>= 1.17.14),
-               rustc (>= 1.9.0+dfsg) [!arm64 !armel !armhf] <!pkg.rustc.dlstage0>,
-               rustc (<= 1.10.0++) [!arm64 !armel !armhf] <!pkg.rustc.dlstage0>,
+Build-Depends: debhelper (>= 9),
+               rustc (>= 1.14.0+dfsg) [!powerpc],
+               rustc (<= 1.15.1++) [!powerpc],
                autotools-dev,
-               binutils-multiarch,
+               binutils,
+               cmake,
                curl,
+               gperf,
+               libedit-dev,
+               llvm-3.9-dev (>= 1:3.9-5),
+               llvm-3.9-tools (>= 1:3.9-5),
                python,
-               nodejs,
                zlib1g-dev,
-               libedit-dev,
-               valgrind,
-               git,
-               procps,
-               cmake,
-# git, procps are necessary for 'make check'
-               antlr4,
-               bison,
-               flex,
-               gdb,
-               default-jdk,
-# above are optional tools for 'make check'
-               llvm-3.8-dev,
-               llvm-3.8-tools
-Build-Depends-Indep: pandoc (>= 1.9),
+               nodejs <!nocheck>,
+               valgrind <!nocheck>,
+               git <!nocheck>,
+               procps <!nocheck>,
+# the tests require the docs to be built, which requires jquery
+               libjs-jquery <!nocheck>,
+# below are optional tools even for 'make check'
+               antlr4 <!nocheck>,
+               bison <!nocheck>,
+               flex <!nocheck>,
+# temporarily disabled because of https://github.com/rust-lang/rust/issues/36323
+# we should be able to re-enable it soon, it seems already fixed in rustc head + gdb trunk
+#               gdb <!nocheck>,
+               default-jdk-headless <!nocheck>,
+Build-Depends-Indep: libjs-jquery <!nodoc>,
+                     pandoc (>= 1.9),
                      po4a,
                      texlive-xetex,
                      texlive-latex-base,
@@ -44,11 +48,11 @@
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-rust/rust.git
 
 Package: rustc
-Architecture: amd64 arm64 armel armhf i386
+Architecture: any
 Multi-Arch: foreign
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}, libstd-rust-dev (= ${binary:Version}),
- gcc, libc-dev
+ gcc, libc-dev, libjs-jquery, binutils (>= 2.26)
 Recommends: rust-gdb | rust-lldb
 Suggests: rust-doc
 Description: Rust systems programming language
@@ -64,9 +68,9 @@
  generic programming and meta-programming, in both static and dynamic
  styles.
 
-Package: libstd-rust-1.10
+Package: libstd-rust-1.15
 Section: libs
-Architecture: amd64 arm64 armel armhf i386
+Architecture: any
 Multi-Arch: same
 Pre-Depends: multiarch-support, ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -87,10 +91,10 @@
 
 Package: libstd-rust-dev
 Section: libdevel
-Architecture: amd64 arm64 armel armhf i386
+Architecture: any
 Multi-Arch: same
 Pre-Depends: multiarch-support
-Depends: ${misc:Depends}, libstd-rust-1.10 (= ${binary:Version})
+Depends: ${misc:Depends}, libstd-rust-1.15 (= ${binary:Version})
 Description: Rust standard libraries - development files
  Rust is a curly-brace, block-structured expression language.  It
  visually resembles the C language family, but differs significantly
@@ -108,7 +112,7 @@
  Rust libraries.
 
 Package: rust-gdb
-Architecture: any
+Architecture: all
 Depends: gdb, ${misc:Depends}
 Replaces: rustc (<< 1.1.0+dfsg1-1)
 Description: Rust debugger (gdb)
@@ -128,8 +132,8 @@
  invoking gdb on rust binaries.
 
 Package: rust-lldb
-Architecture: any
-Depends: lldb, ${misc:Depends}
+Architecture: all
+Depends: lldb-3.9, ${misc:Depends}, python-lldb-3.9
 Replaces: rustc (<< 1.1.0+dfsg1-1)
 Description: Rust debugger (lldb)
  Rust is a curly-brace, block-structured expression language.  It
