=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk
#RUSTFLAGS = -C link-args="$(LDFLAGS)"
# temporary workaround for https://github.com/rust-lang/rust/issues/31529
# this will FAIL if LDFLAGS itself contains shell-interpreted chars beyond
# unquoted spaces (that addprefix works around the failure of)
RUSTFLAGS = $(addprefix -C link-args=,$(LDFLAGS))
export CFLAGS CXXFLAGS CPPFLAGS LDFLAGS RUSTFLAGS

# see https://github.com/rust-lang/rust/issues/37320
# it should be possible to remove this in the next Debian release
export MALLOC_CONF = lg_dirty_mult:-1

# Defines DEB_*_RUST_TYPE triples
include debian/architecture.mk

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# When using sudo pbuilder, this will cause mk/install.mk to run sudo,
# but we don't need sudo as a build-dep for the package if we unexport
# the SUDO_USER variable.
unexport SUDO_USER

# src/rt/miniz.c (incorrectly) triggers -Wmisleading-indentation with
# gcc-6.  See bug #811573.
CFLAGS += -Wno-misleading-indentation

# Debhelper clears MAKEFLAGS, so we have to do this again for any
# target where we call $(MAKE) directly.  Boo.
DEB_PARALLEL_JOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
PMAKE = $(MAKE) $(if $(DEB_PARALLEL_JOBS),-j$(DEB_PARALLEL_JOBS))

# Release type (one of beta, stable or nightly)
RELEASE_CHANNEL := stable
# See also ./build-preview-dsc.sh for a script that builds a beta/nightly .dsc
# out of this packaging. Furthermore, if the build breaks after importing a new
# upstream stable release, check the do_temporary_fixup function in that file
# to see if we already know what fix to make.

DEB_DESTDIR := $(CURDIR)/debian/tmp

RUST_VERSION := $(shell dpkg-parsechangelog --show-field Version | sed -re 's/([^.]+)\.([^.]+)\..*/\1.\2/')
LIBSTD_PKG := libstd-rust-$(RUST_VERSION)

# These are the normal build flags
DEB_CONFIGURE_FLAGS = \
               --host=$(DEB_HOST_RUST_TYPE) \
               --target=$(DEB_TARGET_RUST_TYPE) \
               --disable-manage-submodules \
               --disable-rustbuild \
               --release-channel=$(RELEASE_CHANNEL) \
               --prefix=/usr

# Use system LLVM (comment out to use vendored LLVM)
OLD_LLVM_VERSION = 3.8
DEB_CONFIGURE_FLAGS += --llvm-root=/usr/lib/llvm-3.9

# Below we detect how we're supposed to bootstrap the stage0 compiler. See
# README.Debian for more details of the cases described below.
#
# Sed expression that matches the "rustc" we have in our Build-Depends field
SED_RUSTC_BUILDDEP := /^Build-Depends:/,/^[^[:space:]\#]/{/\s*rustc.*,/$$action}
PRECONFIGURE_CHECK = :
HAVE_BINARY_TARBALL := $(shell ls -1 dl/*$(DEB_HOST_RUST_TYPE)* 2>/dev/null | wc -l)
# allow not using the binary tarball although it exists
ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 armhf i386 ppc64el s390x))
  HAVE_BINARY_TARBALL := 0
endif
ifeq (0,$(HAVE_BINARY_TARBALL))
    # Case A (Building from source): the extracted source tree does not include
    # a bootstrapping tarball for the current architecture e.g. because the
    # distro already has a rustc for this arch, or the uploader expects that
    # this requirement be fulfilled in some other way.
    #
    # Case A-1: the builder did not select the "pkg.rustc.dlstage0" build profile.
    # In this case, we use the distro's rustc - either the previous or current version.
    ifeq (,$(findstring pkg.rustc.dlstage0,$(DEB_BUILD_PROFILES)))
        DEB_CONFIGURE_FLAGS += --enable-local-rust --local-rust-root=/usr
    endif
    #
    # Case A-2: the builder selected the "dlstage0" build profile.
    # In this case, the rust build scripts will download a stage0 into dl/ and use that.
    # We don't need to do anything specific in this build file, so this case is empty.
else
    # Case B (Bootstrapping a new distro): the extracted source tree does
    # include a bootstrapping tarball for the current architecture; see the
    # `source_orig-dl` target below on how to build this.
    #
    # In this case, we'll bootstrap from the stage0 given in that tarball.
    # To ensure the uploader of the .dsc didn't make a mistake, we first check
    # that rustc isn't a Build-Depends for the current architecture.
    ifneq (,$(shell action=p; sed -ne "$(SED_RUSTC_BUILDDEP)" debian/control))
    ifeq (,$(shell action=p; sed -ne "$(SED_RUSTC_BUILDDEP)" debian/control | grep '!$(DEB_HOST_ARCH)'))
        PRECONFIGURE_CHECK = $(error found matches for dl/*$(DEB_HOST_RUST_TYPE)*, \
          but rustc might be a Build-Depends for $(DEB_HOST_ARCH))
    endif
    endif
endif

BUILD_DOCS = 1
ifneq (,$(findstring nodoc,$(DEB_BUILD_PROFILES)))
  DEB_CONFIGURE_FLAGS += --disable-docs
  BUILD_DOCS =
endif

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
  DEB_CONFIGURE_FLAGS += --disable-optimize --disable-optimize-cxx --disable-optimize-llvm
endif


%:
	dh $@ --parallel

# Note: SHELL is not set by dash, but the configure script wants to use it
override_dh_auto_configure:
	ld --version

	: # FIXME: These should be part of the -dl tarball ...
	echo 'e800622715e1122263ece76ab30b0d6be300b992f241de945438623c39b475eb  rustc-1.14.0-aarch64-unknown-linux-gnu.tar.gz' \
	  > dl/rustc-1.14.0-aarch64-unknown-linux-gnu.tar.gz.sha256
	echo 'dc2c5dd293971cf82aaa34b1b1c0823de76ebbc8df10a9fe527455862e1db62f  rustc-1.14.0-arm-unknown-linux-gnueabi.tar.gz' \
	  > dl/rustc-1.14.0-arm-unknown-linux-gnueabi.tar.gz.sha256
	echo '12d91c29e0bfc47168bf801a19153e91dbe6fac37dd47884a8268ba7477ef3ea  rustc-1.14.0-armv7-unknown-linux-gnueabihf.tar.gz' \
	  > dl/rustc-1.14.0-armv7-unknown-linux-gnueabihf.tar.gz.sha256
	echo 'af22508823865245dc1c451d79679c33898092573608017b5b4b764b1dfe205e  rustc-1.14.0-i686-unknown-linux-gnu.tar.gz' \
	  > dl/rustc-1.14.0-i686-unknown-linux-gnu.tar.gz.sha256
	echo 'f01fa663b1f8290c1d8f3542b6c7376f2188a63aa6b3eccde3c46479a405597d  rustc-1.14.0-powerpc-unknown-linux-gnu.tar.gz' \
	  > dl/rustc-1.14.0-powerpc-unknown-linux-gnu.tar.gz.sha256
	echo '1a7710324bd6508aa04d6a279e38ed8e8ea096edb2aceb600cf1843f8d161af3  rustc-1.14.0-powerpc64le-unknown-linux-gnu.tar.gz' \
	  > dl/rustc-1.14.0-powerpc64le-unknown-linux-gnu.tar.gz.sha256
	echo '5b3f57fd2e09630724c12ecce10761439700a7b6838cdefe9e474b3d5640a083  rustc-1.14.0-s390x-unknown-linux-gnu.tar.gz' \
	  > dl/rustc-1.14.0-s390x-unknown-linux-gnu.tar.gz.sha256
	echo '3df0ba1f65366e9220788b13ff0b91a2c3e46bfde196d54b233038157d040a9e  rustc-1.14.0-x86_64-unknown-linux-gnu.tar.gz' \
	  > dl/rustc-1.14.0-x86_64-unknown-linux-gnu.tar.gz.sha256

	# fail the build if we have any instances of OLD_LLVM_VERSION in debian, except for debian/changelog
	! grep --color=always -i 'll...$(OLD_LLVM_VERSION)' --exclude=changelog -R debian
	$(PRECONFIGURE_CHECK)
	SHELL=/bin/sh PATH="$$PWD/debian/bin:$$PATH" DEB_HOST_ARCH="$(DEB_HOST_ARCH)" \
	    ./configure $(DEB_CONFIGURE_FLAGS)

override_dh_auto_clean:
	set -e; \
	if [ -f Makefile ]; then \
	  $(MAKE) clean-all; \
	  $(RM) Makefile config.stamp config.mk; \
	fi
	$(RM) src/rt/hoedown/src/html_blocks.c # clean up after building this ourselves
	$(RM) src/bootstrap/bootstrap.pyc
	$(RM) dl/*.sha256

# upstream bundles this in the source, but in Debian we rebuild everything yo
generate-sources:
	$(MAKE) -C src/rt/hoedown src/html_blocks.c

override_dh_auto_build-arch: generate-sources
	dh_auto_build -- all VERBOSE=1

# note: this is only for buildds that want to do a separate arch:all build;
# there is no point running this yourself "to save time" since it implicitly
# depends on build-arch anyways.
override_dh_auto_build-indep: generate-sources
ifneq (,$(BUILD_DOCS))
	dh_auto_build -- docs VERBOSE=1
endif

override_dh_auto_install:
	dh_auto_install --destdir=$(DEB_DESTDIR)

	mkdir -p $(DEB_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/
	mv $(DEB_DESTDIR)/usr/lib/lib*.so $(DEB_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/

	# Replace duplicated compile-time/run-time dylibs with symlinks
	@set -e; \
